/*
polyprint.v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package polyprintapi

import (
	"encoding/json"
)

// checks if the NfcOrderRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NfcOrderRequest{}

// NfcOrderRequest struct for NfcOrderRequest
type NfcOrderRequest struct {
	Address *NfcOrderRequestAddress `json:"address,omitempty"`
	ChannelId interface{} `json:"channel_id,omitempty"`
	CustomerExperienceId interface{} `json:"customer_experience_id,omitempty"`
	UserId interface{} `json:"user_id,omitempty"`
}

// NewNfcOrderRequest instantiates a new NfcOrderRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNfcOrderRequest() *NfcOrderRequest {
	this := NfcOrderRequest{}
	return &this
}

// NewNfcOrderRequestWithDefaults instantiates a new NfcOrderRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNfcOrderRequestWithDefaults() *NfcOrderRequest {
	this := NfcOrderRequest{}
	return &this
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *NfcOrderRequest) GetAddress() NfcOrderRequestAddress {
	if o == nil || IsNil(o.Address) {
		var ret NfcOrderRequestAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NfcOrderRequest) GetAddressOk() (*NfcOrderRequestAddress, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *NfcOrderRequest) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given NfcOrderRequestAddress and assigns it to the Address field.
func (o *NfcOrderRequest) SetAddress(v NfcOrderRequestAddress) {
	o.Address = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcOrderRequest) GetChannelId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcOrderRequest) GetChannelIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return &o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *NfcOrderRequest) HasChannelId() bool {
	if o != nil && IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given interface{} and assigns it to the ChannelId field.
func (o *NfcOrderRequest) SetChannelId(v interface{}) {
	o.ChannelId = v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcOrderRequest) GetCustomerExperienceId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcOrderRequest) GetCustomerExperienceIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return &o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *NfcOrderRequest) HasCustomerExperienceId() bool {
	if o != nil && IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given interface{} and assigns it to the CustomerExperienceId field.
func (o *NfcOrderRequest) SetCustomerExperienceId(v interface{}) {
	o.CustomerExperienceId = v
}

// GetUserId returns the UserId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcOrderRequest) GetUserId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcOrderRequest) GetUserIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return &o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *NfcOrderRequest) HasUserId() bool {
	if o != nil && IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given interface{} and assigns it to the UserId field.
func (o *NfcOrderRequest) SetUserId(v interface{}) {
	o.UserId = v
}

func (o NfcOrderRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NfcOrderRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if o.ChannelId != nil {
		toSerialize["channel_id"] = o.ChannelId
	}
	if o.CustomerExperienceId != nil {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	if o.UserId != nil {
		toSerialize["user_id"] = o.UserId
	}
	return toSerialize, nil
}

type NullableNfcOrderRequest struct {
	value *NfcOrderRequest
	isSet bool
}

func (v NullableNfcOrderRequest) Get() *NfcOrderRequest {
	return v.value
}

func (v *NullableNfcOrderRequest) Set(val *NfcOrderRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableNfcOrderRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableNfcOrderRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNfcOrderRequest(val *NfcOrderRequest) *NullableNfcOrderRequest {
	return &NullableNfcOrderRequest{value: val, isSet: true}
}

func (v NullableNfcOrderRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNfcOrderRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


